
#include "satsolver.h" 
#include "cnf.h"
#include <cassert>

/*
// Brute Force Solver
bool SatAssignment::Solve(std::vector<SatFormula*>& formulas)
{
	std::set<std::string> variables;
	for(SatFormula* formula : formulas)
		formula->CollectVariables(&variables);
	values.clear();
	for(std::string v : variables)
		values[v] = false;
	return Solve(formulas, values.begin());
}

bool SatAssignment::Solve(std::vector<SatFormula*>& formulas, std::map<std::string, bool>::iterator v)
{
	if(v == values.end())
	{
		for(SatFormula* formula : formulas)
			if(!formula->Evaluate(this))
				return false;
		return true;
	}
	std::map<std::string, bool>::iterator next = v;
	next++;
	v->second = false;
	if(Solve(formulas, next))
		return true;
	v->second = true;
	return Solve(formulas, next);
}
*/


bool SatSolver::SatSolver::SolveCnf(Cnf::CnfFormula* cnf)
{
	if(cnf->numUnsolvedClauses <= 0)
		return true;


	Cnf::CnfClause* bestclause = nullptr;
	for(Cnf::CnfClause* clause : cnf->clauses)
	{
		if(clause->numSatisfiedLiterals > 0) // clause is already satisfied
			continue;

		if(bestclause == nullptr || (clause->numUnassignedLiterals) < (bestclause->numUnassignedLiterals))
			bestclause = clause;
	}

	for(Cnf::CnfLiteral* l : bestclause->literals)
	{
		if(l->variable->value != Cnf::CnfVariableValue::Undefined)
			continue;

		l->variable->SetValue(l->positive ? Cnf::CnfVariableValue::True : Cnf::CnfVariableValue::False);
		assert(bestclause->numSatisfiedLiterals > 0);
		if(SolveCnf(cnf))
			return true;
		l->variable->SetValue(Cnf::CnfVariableValue::Undefined);
		assert(bestclause->numSatisfiedLiterals == 0);
	}
	

	/*
	Cnf::CnfVariable* bestvariable = nullptr;
	for(Cnf::CnfVariable* variable : cnf->variables)
	{
		if(variable->value != Cnf::CnfVariableValue::Undefined) // variable already has a value
			continue;
		//if(bestvariable == nullptr
		//||
	}
	*/


	


	return false;
}
